From 10d9fe6acf572602b41493fbfe74e6178dc9a320 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Thu, 2 Feb 2012 13:09:12 -0600
Subject: Adds admin defined strict letter names

---
 admin/settings/grades.php       |   16 +++++++++++++++-
 grade/edit/letter/edit_form.php |   21 ++++++++++++++++++++-
 lang/en/grades.php              |    7 +++++--
 3 files changed, 40 insertions(+), 4 deletions(-)

diff --git a/admin/settings/grades.php b/admin/settings/grades.php
index 547137c..48502fc 100644
--- a/admin/settings/grades.php
+++ b/admin/settings/grades.php
@@ -175,7 +175,21 @@ if (has_capability('moodle/grade:manage', $systemcontext)
     $temp = new admin_settingpage('letterssettings', $letters_settings_str, 'moodle/grade:manageletters');
     if ($ADMIN->fulltree) {
         $temp->add(new admin_setting_configcheckbox('grade_letters_custom',
-            get_String('letterscustompercents', 'grades'), get_string('letterscustompercents_help', 'grades'), 0));
+            get_string('letterscustompercents', 'grades'), get_string('letterscustompercents_help', 'grades'), 0));
+
+
+        $temp->add(new admin_setting_configcheckbox('grade_letters_strict',
+            get_string('lettersstrictletter', 'grades'), get_string('lettersstrictletter_help', 'grades'), 0));
+
+        $params = array('courseid' => 0);
+
+        $db_scales = $DB->get_records_menu('scale', $params, '', 'id, name');
+
+        $scales = array(0 => get_string('lettersdefaultletters', 'grades')) + $db_scales;
+
+        $temp->add(new admin_setting_configselect('grade_letters_names',
+            get_string('lettersnames', 'grades'),
+            get_string('lettersname_help', 'grades'), 0, $scales));
     }
     $ADMIN->add('grades', $temp);
 
diff --git a/grade/edit/letter/edit_form.php b/grade/edit/letter/edit_form.php
index 4854f4a..106a3f4 100644
--- a/grade/edit/letter/edit_form.php
+++ b/grade/edit/letter/edit_form.php
@@ -24,6 +24,8 @@ require_once $CFG->libdir.'/formslib.php';
 class edit_letter_form extends moodleform {
 
     public function definition() {
+        global $DB;
+
         $mform =& $this->_form;
         $num   = $this->_customdata['num'];
         $admin = $this->_customdata['admin'];
@@ -47,12 +49,29 @@ class edit_letter_form extends moodleform {
         }
 
         $custom = get_config('moodle', 'grade_letters_custom');
+        $strict = get_config('moodle', 'grade_letters_strict');
+
+        $default = get_config('moodle', 'grade_letters_names');
+
+        if ($default and $scale = $DB->get_record('scale', array('id' => $default))) {
+            $default_letters = $scale->scale;
+        } else {
+            $default_letters = get_string('lettersdefaultletters', 'grades');
+        }
+
+        $default_letters = array_reverse(explode(',', $default_letters));
+        $letters = array_combine($default_letters, $default_letters);
 
         for($i=1; $i<$num+1; $i++) {
             $gradelettername = 'gradeletter'.$i;
             $gradeboundaryname = 'gradeboundary'.$i;
 
-            $mform->addElement('text', $gradelettername, $gradeletter." $i");
+            if ($strict) {
+                $mform->addElement('select', $gradelettername, $gradeletter." $i", $letters);
+            } else {
+                $mform->addElement('text', $gradelettername, $gradeletter." $i");
+            }
+
             if ($i == 1) {
                 $mform->addHelpButton($gradelettername, 'gradeletter', 'grades');
             }
diff --git a/lang/en/grades.php b/lang/en/grades.php
index edb2133..86f4193 100644
--- a/lang/en/grades.php
+++ b/lang/en/grades.php
@@ -373,8 +373,11 @@ $string['letterreal'] = 'Letter (real)';
 $string['letters'] = 'Letters';
 $string['letterscustompercents'] = 'Custom Percentages';
 $string['letterscustompercents_help'] = 'Allows for users to enter a value for the percents.';
-$string['lettersdecimals'] = 'Decimal Rounding';
-$string['lettersdecimals_help'] = 'If using _' . $string['letterscustompercents'] . '_, then round to this decimal.';
+$string['lettersdefaultletters'] = 'F,D,C,B,A';
+$string['lettersstrictletter'] = 'Strict Letter names';
+$string['lettersstrictletter_help'] = 'This setting forces the default letter names defined with the selected Letter names.';
+$string['lettersnames'] = 'Letter names';
+$string['lettersname_help'] = 'This setting forces the default letter names defined with this system scale. __Note__: The default letter names are A-F.';
 $string['linkedactivity'] = 'Linked activity';
 $string['linkedactivity_help'] = 'This setting specifies an activity to which this outcome item is linked. This may be used to measure student performance on criteria not assessed by the activity grade.';
 $string['linktoactivity'] = 'Link to {$a->name} activity';
-- 
1.7.1


